// BGG wmm
extern int wmmread(int, char*, int);
extern int wmmlseek(int, int, int);
extern void post(char *fmt, ...);
//#include "../../../src/rtcmix/byte_routines.h"


inline unsigned uswapit(unsigned ul) {
    return (ul >> 24) | ((ul >> 8) & 0xff00) | ((ul << 8) & 0xff0000) | (ul << 24);
}

inline int iswapit(int x) { return uswapit((unsigned)x); }

inline float fswapit(float uf) {
    union { unsigned l; float f; } u;
    u.f = uf;
    u.l = uswapit(u.l);
    return (u.f);
}




/* lpcheader.c -- lpc data header parsing.  DAS 2/92 */
#include <stdio.h>
#include <sys/file.h>
#include <unistd.h>
#include <ugens.h>
#include "lp.h"
#include "lpcheader.h"

LPHEADER analheader;

int
checkForHeader(int afd, int *nPoles, float sr)
{
	int magic[2], headersize=0;
	/* see if second 32 bytes are the lpc header magic number */
// BGG wmm
//	if(read(afd, (char *) magic, sizeof(magic)) != sizeof(magic)) {
	if(wmmread(afd, (char *) magic, sizeof(magic)) != sizeof(magic)) {
		die("dataset", "Can't read analysis file.");
		return -1;
	}
// BGG wmm
//	else lseek(afd, 0, 0);	/* back to beginning */
	else wmmlseek(afd, 0, 0);	/* back to beginning */

// BGG wmm -- swap 'em
	magic[0] = iswapit(magic[0]);
	magic[1] = iswapit(magic[1]);

	if(magic[1] == LP_MAGIC) {	/* has header */
// BGG wmm
//		if(read(afd, (char *) &analheader, sizeof(analheader))
		if(wmmread(afd, (char *) &analheader, sizeof(analheader))
				!= sizeof(analheader)) {
			die("dataset", "Can't read analysis file header.");
			return -1;
		}
		rtcmix_advise("dataset", "This is a csound-type data file with header.");

// BGG wmm -- swap 'em
		analheader.headersize = iswapit(analheader.headersize);
		analheader.lpmagic = iswapit(analheader.lpmagic);
		analheader.npoles = iswapit(analheader.npoles);
		analheader.nvals = iswapit(analheader.nvals);
		analheader.framrate = fswapit(analheader.framrate);
		analheader.srate = fswapit(analheader.srate);
		analheader.duration = fswapit(analheader.duration);


// BGG wmm
//		if(lseek(afd, analheader.headersize, 0) < 0) {
		if(wmmlseek(afd, analheader.headersize, 0) < 0) {
			die("dataset", "Bad lseek past header.");
			return -1;
		}
		if(*nPoles != 0 && *nPoles != analheader.npoles) {
			die("dataset", "LPC header indicates %d poles--check your numbers.", analheader.npoles);
			return -1;
		}
		else if (analheader.npoles > MAXPOLES) {
			die("dataset", "LPC header %d poles > MAXPOLES (%d)!",
					analheader.npoles, MAXPOLES);
			return -1;
		}
		else if(!*nPoles) /* if none previously specified */
			rtcmix_advise("dataset", "npoles set to %d", *nPoles=analheader.npoles);
		if(sr != 0.0 && sr != analheader.srate) {
			warn("dataset",
				 "Warning: LPC header SR (%.1f) != soundfile SR (%.1f)!", 
				 analheader.srate, sr);
		}
		/* for all future lseeks */
		headersize = analheader.headersize;	
	}
	else if(!*nPoles) {	/* no header and no poles specified */
		die("dataset", "You must specify the number of poles for this file!");
		return -1;
	}
	return headersize;
}
